<template lang="pug">
form.form( v-if='modelValue' @submit.prevent='emit("submit")' )
	b-field( label="Название группы" on-border )
		b-input( v-model='name' )
	b-field
		.is-flex.is-align-items-center.is-justify-content-flex-start
			p.is-size-6.has-text-weight-bold.has-text-black Добавлено пользователей: {{ clients.length }}
			.button.is-info.is-light.is-small.ml-2( @click='activeSelector = true' ) Изменить
	b-field
		button.button.is-primary( :class='{ "is-loading": loading }' ) {{ edit ? "Сохранить" : "Создать" }}

transition( name="fade" )
	user-selector( v-model='clients' :active='activeSelector' @close='activeSelector = false' )
</template>

<script setup>
import BField from "@/components/form/Field.vue"
import BInput from "@/components/form/Input.vue"
import UserSelector from "@/components/group/UserSelector.vue"

import { ref, computed, watch, onMounted } from "vue"

const props = defineProps({
	modelValue: {
		type: Object,
		default: () => ({})
	},
	loading: Boolean,
	edit: Boolean
})

const emit = defineEmits([ "update:modelValue", "submit" ])

const defaultValue = {
	name: "",
	clients: []
}

const name = computed({
	get: () => props.modelValue?.name,
	set: name => emit("update:modelValue", { clients: clients.value, name })
})
const clients = computed({
	get: () => props.modelValue?.clients,
	set: clients => emit("update:modelValue", { name: name.value, clients })
})

watch(() => [ name, clients ], () => emit())

const activeSelector = ref(false)

onMounted(() => {
	if (!props.modelValue || !Object.keys(props.modelValue).length)
		emit("update:modelValue", defaultValue)
})
</script>